#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>

#include "V3.h"

class FrameBuffer : public Fl_Gl_Window {
public:
	unsigned int *pix; // pixel array
	int w, h;
	FrameBuffer(int u0, int v0, int _w, int _h);
	void draw();
	void KeyboardHandle();
	int handle(int guievent);
	void SetBGR(unsigned int bgr);
	void Set(int u, int v, int col);
	void SetGuarded(int u, int v, int col);
	void SetChecker(unsigned int col0, unsigned int col1, int csize);
	void DrawAARectangle(V3 tlc, V3 brc, unsigned int col);
	void DrawDisk(V3 center, float r, unsigned int col);
	void DrawSegment(V3 p0, V3 p1, unsigned int col);
	void DrawSegment(V3 p0, V3 p1, V3 c0, V3 c1);
	void LoadTiff(char* fname);
	void SaveAsTiff(char* fname);
};